(function() {
  var dict = {
      "SetupOrgTitle": "Set up a Coveo Organization",
      "SetupOrgDescription": "Link Coveo for Salesforce to your new or existing Coveo Organization",
      "SetupOrgAlreadySetupTitle": "Use an existing Coveo Organization",
      "SetupOrgAlreadySetupCloud": "Already have a Coveo Cloud Organization?",
      "SetupOrgAlreadySetupOnPrem": "Already have an on-premises Coveo setup?",
      "SetupOrgCreateNewOrgTitle": "Create a new Coveo Cloud Organization",
      "SetupOrgChooseNameTitle": "Choose the name of the Coveo Organization to create:",
      "SetupOrgChooseSalesforceContentTitle": "Select the Salesforce content to make searchable",
      "SetupOrgCreateOrgDescription": "You will be prompted to grant the Coveo Platform access to your Salesforce organization.<br/>Once access is granted, the Coveo Platform will connect to your Salesforce organization and index your content.",
      "SetupOrgCreateOrgTitle": "Create Organization",
      "SetupOrgLinkOnPremiseMasterUrl": "Coveo Master Server URL",
      "SetupOrgLinkOnPremiseButton": "Link your on-premise setup",
      "SetupOrgLinkCloudButton": "Link your Coveo Organization",
      "SetupOrgLinkCloudDescription": "When you click <b>LINK YOUR COVEO ORGANIZATION</b>, you will be prompted to log in and authorize the Coveo Salesforce Integration to communicate with your Coveo Cloud Organization.",
      "SetupOrgLinkOnPremiseError": "Coveo Master Server URL is required",
      "SetupOrgLinkOnPremisePlaceholder": "http://myserver.com:8080 (base URL with the REST search API port without the path /rest/search)",
      "SetupOrgNameEmptyError": "Please choose an Organization name",
      "IndexContentTitle": "Index Content",
      "IndexContentTitleBig": "Watch content being indexed!",
      "IndexContentTitleDescription": "Your content is being indexed and therefore not yet searchable. When indexing is complete, an email will be sent to ",
      "IndexContentDescription": "Follow the indexing status of your content in the Coveo Organization",
      "IndexContentContinueDescription": "All sources must have at least one document indexed",
      "IndexContentSkipDescription": "Skip right away to Configure a Search Interface",
      "ConfigureSearchPanelTitle": "Configure a Search Interface",
      "ConfigureSearchPanelDescription": "Configure a search interface and view search results",
      "ConfigureSearchPanelIntroTitle": "View your first search results!",
      "ConfigureSearchPanelIntroDescription": "Use the Interface Editor to easily create and customize your first search page or Insight panel.",
      "ConfigureSearchPanelEditorTitle": "Use the Interface Editor to easily create and customize your first search page or Insight panel.",
      "ConfigureSearchPanelEditorSearchPage": "Configure a Coveo Search Page",
      "ConfigureSearchPanelEditorSidePanel": "Configure a Coveo Insight Panel",
      "ConfigureSearchPanelEditorHelpIntro": "More help available only a click away",
      "ConfigureSearchPanelOnlineHelp": "Read our official product documentation",
      "ConfigureSearchPanelDevelopers": "Read the documentation from our developers",
      "ConfigureSearchPanelAnswers": "Find answers from our staff on our Q&A forum",
      "ConfigurationViewCloudOrg": "View your Coveo Cloud Organization",
      "ConfigurationSearchTitle": "Configure Search",
      "ConfigurationExpandedLink": "Configure the Coveo Expanded Search Link",
      "ConfigurationExpandedLinkTitle": "Configure the Coveo Expanded Search Link",
      "ConfigurationExpandedLinkExplanation": "When a user clicks on the Coveo expanded search link, choose what opens:",
      "ConfigurationExpandedLinkStandardExplanation": "Full featured Coveo for Salesforce search page.",
      "ConfigurationExpandedLinkStandardButton": "Coveo Search Page",
      "ConfigurationExpandedLinkCustomExplanation": "A custom access point such as an on-premises or Salesforce search page.",
      "ConfigurationExpandedLinkCustomButton": "Custom Page (URL)",
      "ConfigurationExpandedLinkCustomSFExplanation": "A Saleforce page that hosts a Coveo search page.",
      "ConfigurationExpandedLinkCustomSFButton": "Salesforce Page",
      "ConfigurationExpandedLinkDisableExplanation": "Disables and removes the Expand button. It will not appear in your interface",
      "ConfigurationExpandedLinkDisableButton": "Disable Link",
      "ConfigurationRelatedActionTitle": "Related Actions",
      "ConfigAdvancedWarning": "Modifying these settings can negatively impact your content privacy.",
      "CoveoAdvancedProfileExplanation": "When a user makes a search query, use the following profile:",
      "CoveoAdvancedObfuscateExplanation": "When a user makes a search query, send hashed information to the Cloud Organization:",
      "CoveoAdvancedObfuscateFull": "Entire E-mail address",
      "CoveoAdvancedObfuscateUsername": "E-mail username",
      "CoveoAdvancedObfuscateNone": "Nothing",
      "GotoFullSearch": "Full Search",
      "ResetYourConfiguration": "Reset Your Configuration",
      "AdvancedConfiguration": "Advanced Configuration",
      "AnonymousProfile": "Anonymous Profile",
      "Querying User Profile": "Querying User Profile",
      "Or": "Or",
      "Close": "Close",
      "SaveChanges": "Save Changes",
      "Saved": "Saved!",
      "SalesforceStandardObjects": "Salesforce standard objects",
      "SalesforceKnowledgeBase": "Salesforce Knowledge Base",
      "SalesforceContent": "Salesforce Content",
      "Available": "Available",
      "Sources": "Create index sources for",
      "Source": "Source",
      "Status": "Status",
      "Documents": "Documents",
      "ETA": "ETA",
      "Continue": "Continue",
      "Help": "Online Help",
      "Developers": "Developers",
      "Answers": "Answers",
      "GoBack": "Go Back",
      "UseUsageAnalyticsProxy": "Use usage analytics proxy",
      "SecondsAgo": "seconds ago",
      "MinutesAgo": "minutes ago",
      "HoursAgo": "hours ago",
      "DaysAgo": "days ago",
      "MonthsAgo": "months ago",
      "YearsAgo": "years ago",
      "ERROR": "Source is in error...",
      "INDEXING": "Indexing ...",
      "IDLE": "Done indexing!",
      "DELETING": "Source is being deleted...",
  }
  var locales = String["locales"] || (String["locales"] = {});
  locales["en"] = _.extend({}, locales["en"], dict);
  String["toLocaleString"].call(this, { "en": dict });
  String["locale"] = "en";
  String["defaultLocale"] = "en";
})();
